#!/usr/local/bin/perl

##############################################################################
#                                                                            #
# HTML-Report version 1.0                                                    #
# Copyright (C) 1999 by ralf ernst,  all rights reserved.                    #
# ralf-ernst@gmx.de    http://www.online.de/home/ralf.ernst/                 #
# HTML-Report is included in the RotaryCounter version 1.02 package          #
# http://ernst.hypermart.net/rotarycounter/                                  #
#                                                                            #
##############################################################################
#                                                                            #
# COPYRIGHT NOTICE                                                           #
# Copyright (C) 1999 by ralf ernst,  all rights reserved.                    #
#                                                                            #
# HTML-Report may be used and modified free of charge by anyone so long as   #
# this copyright notice and the comments above remain intact. By using this  #
# code you agree to indemnify ralf ernst from any liability that             #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden. In other words, please ask first before you try and   #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium. In all cases copyright and header must remain intact. #
#                                                                            #
##############################################################################


$log_file = "/full/path/to/file-log.txt";

$max_days_shown = 30;

$title_url = "http://ernst.hypermart.net/rotarycounter/";
$title = "The RotaryCounter Homepage";


##############################################################################
# Nothing below this line has to be changed                                  #
##############################################################################

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
@weekday = ( "Sun","Mon","Tue","Wed","Thu","Fri","Sat" );
if ($sec < 10)   { $sec = "0$sec";  }
if ($min < 10)   { $min = "0$min";  }
if ($hour  < 10) { $hour= "0$hour"; }
if ($mday  < 10) { $mday= "0$mday"; }
if ($mon++ < 10) { $mon = "0$mon";  }
$year += 1900;
$date_now = "$mday/$mon/$year,$weekday[$wday],$hour:$min:$sec";

print "Content-type: text/html\n\n";

open(LOG,"$log_file") || die "Cannot Open Log File $log_file: $!";
@lines = <LOG>;
close(LOG);

$lines_number = @lines;

if ($lines[1] =~ /\[(.*)\] - (.*) - (.*) - .*/) {
   $date_start = $1;
}
if ($lines[($lines_number - 1)] =~ /\[(.*)\] - (.*) - (.*) - .*/) {
   $date_end = $1;
}

foreach $line (@lines) {
   if ($line =~ /\[(.*)\/(.*)\/(.*),(.*),(.*):(.*):(.*)\] - (.*) - (.*) - .*/) {
      ($day,$month,$year,$weekday,$hour,$minute,$second,$remote_host,$user_agent) =
         ($1,$2,$3,$4,$5,$6,$7,$8,$9);

      if ($day ne '' && $month ne '' && $year ne '') {
         $day_str = "$year/$month/$day";
         push(@DAYS, $day_str);
         $total_visits++;
      }
      if ($hour ne '') {
         push(@HOURS, $hour);
      }
      if ($user_agent ne '' && $user_agent ne '-') {
         push( @BROWSER, &get_browser($user_agent) );
         push( @OP_SYSTEM, &get_op_system($user_agent) );
         $total_user_agent++;
      }
   }
}

foreach (@DAYS) {
   $day{($_)[0]}++;
}
foreach (@BROWSER) {
   $browser{($_)[0]}++;
}
foreach (@OP_SYSTEM) {
   $op_system{($_)[0]}++;
}
foreach (@HOURS) {
   $hour{($_)[0]}++;
}

&html_header;
&html_days;
&html_hours;
&html_browser;
&html_op_system;
&html_footer;

exit;


sub html_header {
   print "<HTML><HEAD><TITLE>Statistic Reports for $title</TITLE></HEAD>\n";
   print "<BODY><DIV ALIGN=CENTER><H1>Statistic Reports for<BR>$title</H1>\n";
   print "A total of <B>$total_visits</B> visitors were reviewed for this logging from<BR>$date_start to $date_end<BR>The reports occurred at $date_now<P>\n";
   print "<P><HR WIDTH=450 SIZE=10>\n";
   print "<B><A HREF=\"$title_url\">$title</A><BR><A HREF=\"\#day\">Day Report</A> | <A HREF=\"\#hour\">Hour Report</A> | <A HREF=\"\#browser\">Browser Report</A>  | <A HREF=\"\#op-system\">OP-System Report</A></B>\n";
   print "<HR WIDTH=450 SIZE=10><P>\n";
}

sub html_days {
   print "\&\#160;<P><A NAME=\"day\"><FONT SIZE=+2><B>Day Report</B></FONT></A><P>\n";
   print "<TABLE BORDER=1 CELLPADDING=4 CELLSPACING=1>\n";
   print "<TR><TH>Day </TH><TH>Number of Hits</TH></TR>\n";

   @days = (sort keys %day);
   $day_length = @days;
   if ( $max_days_shown>$day_length ) { $max_days_shown=$day_length; }
   for (local $i=$max_days_shown - $i; $i>0; $i-- ) {
      ($year,$mon,$mday) = split(/\//, $days[($day_length - $i)]);
      print "<TR><TH>$mday/$mon/$year</TH><TH>$day{$days[($day_length - $i)]}</TH></TR>\n";
   }
   print "</TABLE><P>\n";
}

sub html_hours {
   print "\&\#160;<P><A NAME=\"hour\"><FONT SIZE=+2><B>Hour Report</B></FONT></A><P>\n";
   print "<TABLE BORDER=1 CELLPADDING=4 CELLSPACING=1>\n";
   print "<TR><TH>Hour</TH><TH>Percent</TH><TH>Number of Hits</TH></TR>\n";

   foreach (sort keys %hour) {
      $percent = (int (10000 * ($hour{$_} / $total_visits)) / 100);
      printf "<TR><TH>$_</TH><TH>%.1f %%</TH><TH>$hour{$_}</TH></TR>\n", $percent;
   }
   print "</TABLE><P>\n";
}

sub html_browser {
   print "\&\#160;<P><A NAME=\"browser\"><FONT SIZE=+2><B>Browser Report</B></FONT></A><P>\n";
   print "<TABLE BORDER=1 CELLPADDING=4 CELLSPACING=1>\n";
   print "<TR><TH>Browser</TH><TH>Percent</TH><TH>Number of Hits</TH></TR>\n";

   foreach (sort { $browser{$b} <=> $browser{$a} } keys %browser) {
      $percent = (int (10000 * ($browser{$_} / $total_user_agent)) / 100);
      printf "<TR><TH>$_</TH><TH>%.1f %%</TH><TH>$browser{$_}</TH></TR>\n", $percent;
   }
   print "</TABLE><P>\n";
}

sub html_op_system {
   print "\&\#160;<P><A NAME=\"op-system\"><FONT SIZE=+2><B>OP-System Report</B></FONT></A><P>\n";
   print "<TABLE BORDER=1 CELLPADDING=4 CELLSPACING=1>\n";
   print "<TR><TH>OP-System</TH><TH>Percent</TH><TH>Number of Hits</TH></TR>\n";

   foreach (sort { $op_system{$b} <=> $op_system{$a} } keys %op_system) {
      $percent = (int (10000 * ($op_system{$_} / $total_user_agent)) / 100);
      printf "<TR><TH>$_</TH><TH>%.1f %%</TH><TH>$op_system{$_}</TH></TR>\n", $percent;
   }
   print "</TABLE><P>\n";
}

sub html_footer {
   print "\&\#160;<P><HR WIDTH=450 SIZE=10>\n";
   print "<B><A HREF=\"$title_url\">$title</A><BR><A HREF=\"\#day\">Day Report</A> | <A HREF=\"\#hour\">Hour Report</A> | <A HREF=\"\#browser\">Browser Report</A>  | <A HREF=\"\#op-system\">OP-System Report</A></B>\n";
   print "<HR WIDTH=450 SIZE=10>\n";
   print "</DIV></BODY></HTML>\n";
}

sub get_browser {
   if ( $_[0] =~ /MSIE/ ) {
      return "MSIE";
   }elsif ( $_[0] =~ /Opera/ ) {
      return "Opera";
   }elsif ( $_[0] =~ /compatible/ ) {
      return "Other";
   }elsif ( $_[0] =~ /Mozilla/ ) {
      return "Netscape";
   }else {
      return "Other";
   }
}

sub get_op_system {
   if ( $_[0] =~ /Win/ ) {
      return "Windows";
   }elsif ( $_[0] =~ /Mac/ ) {
      return "Macintosh";
   }elsif ( $_[0] =~ /X11/ ) {
      return "Unix";
   }else {
      return "Other";
   }
}

##############################################################################
#                                                                            #
# History:                                                                   #
#                                                                            #
# 25/Mar/99 version 1.0    first version running on server                   #
#                                                                            #
##############################################################################
