#!/usr/local/bin/perl

##############################################################################
#                                                                            #
# RotaryCounter version 1.06                                                 #
# Copyright (C) 1999 by ralf ernst,  all rights reserved.                    #
# ralf-ernst@gmx.de    http://www.online.de/home/ralf.ernst/                 #
# The RotaryCounter delivers an animated Counter-Output with the help of FLY #
# http://ernst.hypermart.net/rotarycounter/                                  #
#                                                                            #
##############################################################################
#                                                                            #
# COPYRIGHT NOTICE                                                           #
# Copyright (C) 1999 by ralf ernst,  all rights reserved.                    #
#                                                                            #
# RotaryCounter may be used and modified free of charge by anyone so long as #
# this copyright notice and the comments above remain intact. By using this  #
# code you agree to indemnify ralf ernst from any liability that             #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden. In other words, please ask first before you try and   #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium. In all cases copyright and header must remain intact. #
#                                                                            #
##############################################################################


$flyprog = "/usr/local/bin/fly";

$gif_dir  = "/full/path/to/rotarycounter/gifs";
$data_dir = "/full/path/to/rotarycounter/data";
$temp_dir = "/full/path/to/rotarycounter/temp";

$image_width = 15;
$image_height = 20;

$frame_number = 20;

$use_log = "1";       #  "1"..yes , "0"..no


##############################################################################
# Do NOT touch anything below this row                                       #
##############################################################################


# Get the date for logging purposes

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
@weekday = ( "Sun","Mon","Tue","Wed","Thu","Fri","Sat" );
if ($sec < 10)   { $sec = "0$sec";  }
if ($min < 10)   { $min = "0$min";  }
if ($hour  < 10) { $hour= "0$hour"; }
if ($mday  < 10) { $mday= "0$mday"; }
if (++$mon < 10) { $mon = "0$mon";  }
$year += 1900;
$date_str = "$mday/$mon/$year,$weekday[$wday],$hour:$min:$sec";


# a few default values for internal usage

$digits = 4;
$account = "error";
$access_try_max = 5;


# Get the input and split the name-value pairs

@pairs = split(/&/, $ENV{'QUERY_STRING'});
foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}
if ( $FORM{'dig'} ) { $digits = $FORM{'dig'} }
if ( $FORM{'acc'} ) { $account = "$FORM{'acc'}" }


# reads counter-data and updates counter-file

$counter = 1;
if (-e "$data_dir/$account-dat.txt") {
   open(CNT_IN,"<$data_dir/$account-dat.txt") || die "Can't open $account-dat.txt: $!\n";
   $counter = <CNT_IN>;
   close(CNT_IN);
   chomp $counter;
   $counter++;
}
open(CNT_OUT,">$data_dir/$account-dat.txt") || die "Can't open $account-dat.txt: $!\n";
flock(CNT_OUT,LOCK_EX);
print CNT_OUT $counter;
flock(CNT_OUT,LOCK_UN);
close(CNT_OUT);


# create gif-files at first start of counter

if ( (! -s "$temp_dir/basis.gif") || (! -s "$temp_dir/row1y.gif") ) {
   &MakeBasisFile;
   &MakeRowFile;
}


# create temporary static gifs with the help of fly

$temp_cnt = $counter-1;
$count_length = length($temp_cnt);
for ($i=0; $i<$digits; $i++) {
   if ($i<$count_length) {
      $count_digit[$i] = chop($temp_cnt);
   } else {
      $count_digit[$i] = "0";
   }
}
$digit_change = 0;
while ( $count_digit[$digit_change] == "9") {
   $digit_change++;
}

$fly_command = "new\n";
$fly_command .= "size ". ($image_width*$digits) .",$image_height\n";
$fly_command .= "name $temp_dir/temp-$account-$counter-00.xxx\n";
$fly_command .= "copy 0,0,-1,-1,-1,-1,$temp_dir/basis.gif\n";
$insert_width = $image_width*($digits-1);
for ($i=0; $i<$digits; $i++) {
   $fly_command .= "copy $insert_width,0,-1,-1,-1,-1,$gif_dir/number$count_digit[$i].gif\n";
   $insert_width -= $image_width; 
}
$fly_command .= "end\n";

$pos_change = int ( $image_height/$frame_number );
for ($frm=0; $frm<=$frame_number; $frm++) {
   $fly_command .= "new\n";
   $fly_command .= "size ". $image_width*($digit_change+1) .",$image_height\n";
   $fly_command .= "name $temp_dir/temp-$account-$counter-$frm.xxx\n";
   $fly_command .= "copy 0,0,-1,-1,-1,-1,$temp_dir/basis.gif\n";
   for ($dig=0; $dig<=$digit_change; $dig++) {
      $pos_x = $image_height * ( 10-$count_digit[$dig] ) - $pos_change * $frm;
      $fly_command .= "copy ". $image_width*($digit_change-$dig) .",0,0,$pos_x,$image_width,". ($pos_x+$image_height) .",$temp_dir/row1y.gif\n";
   }
   $fly_command .= "end\n";
}
chomp $fly_command;

open(FLY,"| $flyprog -q");
print FLY $fly_command;
close (FLY);


# extract image-data from temporary gif-files and display animated gif

&GetColorTable("$temp_dir/temp-$account-$counter-00.xxx");
&GetImageData("$temp_dir/temp-$account-$counter-00.xxx");
unlink("$temp_dir/temp-$account-$counter-00.xxx");

$gif_anim_control = "\x21\xF9\x04\x00\x0A\x00\x00\x00";
$gif_anim_control_0 = "\x21\xF9\x04\x00\xC8\x00\x00\x00";
$gif_header = "GIF89a". &lsb_msb($image_width*$digits) . &lsb_msb($image_height) . $color_table_byte ."\x00\x00";
$gif_footer = "\x3B";
$gif_image_control = "\x2C". &lsb_msb($image_width*($digits-$digit_change-1)) ."\x00\x00". &lsb_msb($image_width*($digit_change+1)) . &lsb_msb($image_height) ."\x00";
$gif_image_control_0 = "\x2C\x00\x00\x00\x00". &lsb_msb($image_width*$digits). &lsb_msb($image_height) ."\x00";
$gif_comment = "\x21\xFE\x85\r\n\r\nThe RotaryCounter is copyrighted\r\n(C) 3.99 by ralf ernst\r\nhttp://ernst.hypermart.net/rotarycounter/\r\nmailto:ralf-ernst\@gmx.de\r\n\r\n\x00";

binmode STDOUT;
print "Content-type: image/gif\n\n";
print $gif_header;
print $gif_color_table;
print $gif_anim_control_0;
print $gif_image_control_0;
print $gif_image_data;
for ($i=0; $i<=$frame_number; $i++) {
   &GetImageData("$temp_dir/temp-$account-$counter-$i.xxx");
   unlink("$temp_dir/temp-$account-$counter-$i.xxx");
   print $gif_anim_control;
   print $gif_image_control;
   print $gif_image_data;
}
print $gif_comment;
print $gif_footer;


# updates log-file if necessary

if ( $use_log eq "1" ) {
   if (-e "$data_dir/$account-log.txt") {
      open(CNT_LOG,">>$data_dir/$account-log.txt") || die "Can't open $account-log.txt: $!\n";
      flock(CNT_LOG,LOCK_EX);
   }else {
      open(CNT_LOG,">$data_dir/$account-log.txt") || die "Can't open $account-log.txt: $!\n";
      flock(CNT_LOG,LOCK_EX);
   }
   print CNT_LOG "[$date_str] - $ENV{'REMOTE_HOST'} - $ENV{'HTTP_USER_AGENT'} - $ENV{'HTTP_REFERER'}\n";
   flock(CNT_LOG,LOCK_UN);
   close(CNT_LOG);
}

exit;


# a few subroutines following

sub GetColorTable {
   while ( $access_tries<$access_try_max ) {
      if ( -s "$_[0]" ) {
         open(GIF_TMP,"<$_[0]") || die "Can't open $_[0]: $!\n";
         last;
      }else {
         $access_tries++;
         sleep 1;
      }
   }
   binmode GIF_TMP;
   $length_file = -s GIF_TMP;

   seek GIF_TMP, 10, 0;
   read GIF_TMP, $color_table_byte, 1;
   $color_table_tmp = $color_table_byte & "\x07";
   $color_table_tmp = vec $color_table_tmp, 0, 8;
   $color_table_length = 2**($color_table_tmp+1);

   seek GIF_TMP, 13, 0;
   read GIF_TMP, $gif_color_table, $color_table_length*3;

   close(GIF_TMP);
}

sub GetImageData {
   while ( $access_tries<$access_try_max ) {
      if ( -s "$_[0]" ) {
         open(GIF_TMP,"<$_[0]") || die "Can't open $_[0]: $!\n";
         last;
      }else {
         $access_tries++;
         sleep 1;
      }
   }
   binmode GIF_TMP;
   $length_file = -s GIF_TMP;

   $start_data = 13 + ($color_table_length*3) + 10;
   seek GIF_TMP, $start_data, 0;
   read GIF_TMP, $gif_image_data, $length_file-$start_data-1;

   close(GIF_TMP);
}

sub lsb_msb {
   local $tmp1 = pack "C", $_[0];
   local $tmp2 = pack "C", int ($_[0]/256);
   return $tmp1.$tmp2;
}

sub MakeBasisFile {
   &GetColorTable("$gif_dir/number0.gif");

   $img_width = int ($color_table_length/$image_height+.5);
   $img_height = $image_height;

   open(FLY,"| $flyprog -q -o $temp_dir/basis.gif");
   print FLY "new\n";
   print FLY "size $img_width,$img_height\n";

   $color_idx=0;
   for ($i=0; $i<$img_height; $i++) {
      for ($j=0; $j<$img_width; $j++) {
         $color_r = substr $gif_color_table,$color_idx*3,1;
         $color_g = substr $gif_color_table,$color_idx*3+1,1;
         $color_b = substr $gif_color_table,$color_idx*3+2,1;
         $color_r = vec $color_r,0,8;
         $color_g = vec $color_g,0,8;
         $color_b = vec $color_b,0,8;
         print FLY "setpixel $j,$i,$color_r,$color_g,$color_b\n";
         if ($color_idx++ >= $color_table_length-1) {
             $color_idx=0;
         }
      }
   }
   close(FLY);
}

sub MakeRowFile {
   open(FLY,"| $flyprog -q -o $temp_dir/row1y.gif");
   print FLY "new\n";
   print FLY "size $image_width,". $image_height*11 ."\n";

   print FLY "copy 0,0,-1,-1,-1,-1,$gif_dir/number0.gif\n";
   for ($i=9; $i>=0; $i--) {
      print FLY "copy 0,". (10-$i)*$image_height .",-1,-1,-1,-1,$gif_dir/number$i.gif\n";
   }
   close(FLY);
}


##############################################################################
#                                                                            #
# History:                                                                   #
#                                                                            #
# 22/Nov/99 version 1.06   october-bugfix, updated the readme.txt file       #
#                                                                            #
# 03/May/99 version 1.05   some bugfix: try to open temporary gifs more than #
#                          once. Reorganised the FLY-execution handling      #
#                          (requires now version 1.4 of the FLY-program)     #
#                                                                            #
# 25/Mar/99 version 1.02   added some text for description purposes          #
#                          reformatted the log-file output for the use with  #
#                          HTML-Report version 1.0                           #
#                                                                            #
# 18/Mar/99 version 1.01   fixed wrong output during multiple script         #
#                          executions at the same time                       #
#                                                                            #
# 16/Mar/99 version 1.00   first version running on server                   #
#                                                                            #
# 19/Feb/99 version 0.50   first animation on local machine                  #
#                                                                            #
##############################################################################
